//
//  PDF2on1  2y[W1y[WɕϊvO
//      by K.Miki   2011/01/26 ver. 1.00
//
import java.io.*;
import java.io.File;
import javax.swing.filechooser.*;
import javax.swing.*;
import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import java.awt.event.*;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.util.*;
import com.itextpdf.text.Document;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.*;

public class PDF2on1 extends JFrame implements ActionListener{
  static JButton button1, button2;
  static JTextField tfw,tfp;
  static String fpath, cwidth;
  static File cpath = new File("");
  static JRadioButton rbauto = new JRadioButton("", true);
  static JRadioButton rblr = new JRadioButton("E");
  static JRadioButton rbud = new JRadioButton("㉺");
  static JCheckBox cbsave = new JCheckBox("ۑmF");
  static JCheckBox cbfirst = new JCheckBox("擪y[WƗ");
  static JCheckBox cbframe = new JCheckBox("gt");
  static JProgressBar pbar = new JProgressBar(1, 100);

  public static void main(String[] args) {
	readini();
    PDF2on1 frame = new PDF2on1();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setBounds(10, 10, 360, 250);
    frame.setTitle("PDF 2 on 1");
    DropTarget dtarget = new DropTarget(button1,new dtAdapter());
	if (args.length==2) {
	   twoOnOne(args[0],args[1]);
	   System.exit(0);
	} else if (args.length==1) {
	   if (cbsave.isSelected()) frame.setVisible(true);
	   twoOnOne(args[0],saveTo(args[0]));
	   System.exit(0);
    } else frame.setVisible(true);
  }

  // Drag & Dropւ̑Ή
  private static class dtAdapter extends DropTargetAdapter {
	 public void drop(DropTargetDropEvent dtde) {
        try {
           Transferable trans = dtde.getTransferable();
           DataFlavor flavors[] = trans.getTransferDataFlavors();
           for (int i = 0; i < flavors.length; ++i)
              if (flavors[i].isFlavorJavaFileListType()) {
				 dtde.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);
                 java.util.List list = (java.util.List) trans.getTransferData(flavors[i]);
                 for (int j = 0; j < list.size(); ++j) {
                    File file = (File) list.get(j);
		            twoOnOne(file.getAbsolutePath(),saveTo(file.getAbsolutePath()));
                 }
              }
        } catch (IOException ioe) {
	       ioe.printStackTrace();
        } catch (UnsupportedFlavorException ufe) {
           ufe.printStackTrace();
        } finally {
           dtde.dropComplete(true);
        }
     }
  }
  
  // ݒWindow̕\
  PDF2on1(){
    getContentPane().setLayout(new GridLayout(7,1));

    button1=new JButton("t@CJ (܂͂Drug & Drop)");
    button1.addActionListener(this);
    getContentPane().add(button1);

	Panel p3=new Panel();
    p3.setLayout(new GridLayout(1,3));
    JLabel lab3=new JLabel();
	lab3.setText("@@y[W̍̕");
	p3.add(lab3);
	Panel p31=new Panel();
    p31.setLayout(new GridLayout(1,3));
	ButtonGroup bg = new ButtonGroup();
	bg.add(rbauto);bg.add(rblr);bg.add(rbud);
	p31.add(rbauto);p31.add(rblr);p31.add(rbud);
	p3.add(p31);
    getContentPane().add(p3);

	Panel p1=new Panel();
    p1.setLayout(new GridLayout(1,2));
    JLabel lab1 = new JLabel();
	lab1.setText("@@Ԃ̋󂫂̕");
	p1.add(lab1);
	tfw = new JTextField(cwidth, 15);
	p1.add(tfw);
    getContentPane().add(p1);

	Panel p2=new Panel();
    p2.setLayout(new GridLayout(1,2));
    JLabel lab2=new JLabel();
	lab2.setText("@@ۑtH_");
	p2.add(lab2);
	tfp=new JTextField(fpath, 64);
	p2.add(tfp);
    getContentPane().add(p2);

	Panel p4=new Panel();
    p4.setLayout(new FlowLayout());
	p4.add(cbfirst);p4.add(cbframe);p4.add(cbsave);
    getContentPane().add(p4);

	Panel p6=new Panel();
    p6.setLayout(new FlowLayout());
    button2=new JButton("ݒۑ");
    button2.addActionListener(this);
    button2.setPreferredSize(new Dimension(120,20));
	p6.add(button2);
    getContentPane().add(p6);
	
	Panel p5=new Panel();
    p5.setLayout(new FlowLayout());
	JLabel lab4=new JLabel();
	lab4.setText("   ver. 1.00  by K.Miki 2011/01/26");
	pbar.setValue(0);
    pbar.setPreferredSize(new Dimension(120,20));
	p5.add(pbar);p5.add(lab4);
    getContentPane().add(p5);
  }
  
  // ۑ߂
  static String saveTo(String fname){
 	JFileChooser fchooser;
  	File ofile,pfile;
  	int i;
	
  	if (cbsave.isSelected()) { /* ۑq˂ */
       if (cpath.getPath().equals("")) fchooser = new JFileChooser();
	   else                            fchooser = new JFileChooser(cpath);
       if (fchooser.showSaveDialog(null)==JFileChooser.APPROVE_OPTION){
          fname=fchooser.getSelectedFile().getPath();
       } else
	      fname="";
  	} else { /* ۑ掩w */
	   ofile=new File(fname);
	   if (ofile.getParent()==null) {
	   	  fname=(new File(".").getAbsoluteFile().getParent())+File.separator+fname;
	   }
	   if (!tfp.getText().equals("")) { /* ۑtH_[̎w肠 */
	      ofile=new File(fname);
		  pfile=new File(ofile.getParent()+File.separator+tfp.getText());
		  if (!pfile.exists()) pfile.mkdir();
		  if (tfp.getText().substring(tfp.getText().length()-1)==File.separator)
		     fname=ofile.getParent()+File.separator+tfp.getText()+ofile.getName();
		  else
		     fname=ofile.getParent()+File.separator+tfp.getText()+File.separator+ofile.getName();
	   }
	   ofile=new File(fname);
	   while (ofile.exists()) {
	      i=fname.lastIndexOf(".pdf");
		  fname=fname.substring(0,i)+"2.pdf";
		  ofile=new File(fname);
	   }
  	}
  	return (fname);
  }

  // ۂ̎dƂ iText̃Tv()̃pN
  static void twoOnOne(String fname, String sname) {
  	 int n,i,dir;
	 float width,height,space=Float.valueOf(tfw.getText());
	 boolean waku=cbframe.isSelected();
	 Document document;
	 
	 if (sname.equals("")) return;
	 if (rbauto.isSelected())    dir=1; /* auto */
	 else if (rblr.isSelected()) dir=2; /* left-rigth */
	 else                        dir=3; /* up-down */
     try {
        PdfReader reader = new PdfReader(fname);
        n=reader.getNumberOfPages();
        Rectangle psize = reader.getPageSize(1);
        width = psize.getWidth();
        height = psize.getHeight();
		if (dir==1) {
		   if (width>height) dir=3;
		   else              dir=2;
		}
		if (dir==2) document=new Document(new Rectangle(width*2+space, height));
		else        document=new Document(new Rectangle(width, height*2+space));
        PdfWriter writer=PdfWriter.getInstance(document,new FileOutputStream(sname));
        document.open();
        PdfContentByte cb = writer.getDirectContent();
		pbar.setMaximum(n);pbar.setValue(0);pbar.paintImmediately(pbar.getVisibleRect());
        for (i=0;i<n;) {
           document.newPage();
           i++;pbar.setValue(i);pbar.paintImmediately(pbar.getVisibleRect());
           PdfImportedPage page1 = writer.getImportedPage(reader, i);
		   if (dir==2) {
              cb.addTemplate(page1, 1, 0, 0, 1, 0, 0);
	          if (waku) {
		         cb.setLineWidth(1f);
		         cb.rectangle(0, 0, width, height);
		         cb.stroke();
		      }
		   } else {
              cb.addTemplate(page1, 1, 0, 0, 1, 0, height+space);
	          if (waku) {
		         cb.setLineWidth(1f);
		         cb.rectangle(0, height+space, width, height*2+space);
		         cb.stroke();
		      }
		   }
		   if (i==1 && cbfirst.isSelected()) continue;
           if (i < n) {
              i++;pbar.setValue(i);pbar.paintImmediately(pbar.getVisibleRect());
              PdfImportedPage page2 = writer.getImportedPage(reader, i);
			  if (dir==2) {
                 cb.addTemplate(page2, 1, 0, 0, 1, width+space, 0);
			     if (waku) {
		            cb.setLineWidth(1f);
		            cb.rectangle(width+space, 0, width*2+space, height);
		            cb.stroke();
			     }
			  } else {
                 cb.addTemplate(page2, 1, 0, 0, 1, 0, 0);
			     if (waku) {
		            cb.setLineWidth(1f);
		            cb.rectangle(0, 0, width, height);
		            cb.stroke();
			     }
			  }
           }
        }
        document.close();
     } catch (Exception de) {
            de.printStackTrace();
     }
  }

  //  ut@CJv{^Ɓuݒۑv{^ւ̑Ή
  public void actionPerformed(ActionEvent e){
     if (e.getSource().equals(button1)) { /* t@CJ */
	 	JFileChooser fchooser;
        if (cpath.getPath().equals("")) fchooser = new JFileChooser();
		else                            fchooser = new JFileChooser(cpath);
        javax.swing.filechooser.FileFilter filter1=new FileNameExtensionFilter("PDF document (*.pdf)","pdf");
        fchooser.addChoosableFileFilter(filter1);
        if (fchooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION){
		   cpath=fchooser.getCurrentDirectory();
           twoOnOne(fchooser.getSelectedFile().getPath(),saveTo(fchooser.getSelectedFile().getPath()));
        }
    } else if (e.getSource().equals(button2)) { /* ݒ̕ۑ */
	   try {
          File file=new File("PDF2on1.ini");
          FileWriter fw=new FileWriter(file);
		  fw.write("[PDF2on1ini]\r\n");
		  fw.write("width="+tfw.getText()+"\r\n");
		  fw.write("path="+tfp.getText()+"\r\n");
		  if (rbauto.isSelected())    fw.write("direction=auto\r\n");
		  else if (rblr.isSelected()) fw.write("direction=leftRight\r\n");
		  else                        fw.write("direction=upDown\r\n");
		  if (cbsave.isSelected()) fw.write("confirm=yes\r\n");
		  else                     fw.write("confirm=no\r\n");
		  if (cbfirst.isSelected()) fw.write("first=only\r\n");
		  if (cbframe.isSelected()) fw.write("frame=yes\r\n");
		  else                      fw.write("frame=no\r\n");
          fw.close();
       } catch(IOException ioe){
		  JOptionPane.showMessageDialog(this,ioe,"ݒ̕ۑł܂" ,
			JOptionPane.INFORMATION_MESSAGE);
       }
    }
  }
  
  // ݒt@C̓ǂݍ
  static void readini() {
     try {
        FileReader in = new FileReader("PDF2on1.ini");
        BufferedReader br = new BufferedReader(in);
        String line;
		fpath="";cwidth="";cbfirst.setSelected(false);
        while ((line = br.readLine()) != null) {
           if (line.indexOf("path=")==0) fpath=line.substring(5).trim();
           if (line.indexOf("width=")==0) cwidth=line.substring(6).trim();
		   if (line.indexOf("direction=auto")==0) {
		   	  rbauto.setSelected(true);
		   	  rblr.setSelected(false);
		   	  rbud.setSelected(false);
		   }
		   if (line.indexOf("direction=leftRight")==0) {
		   	  rbauto.setSelected(false);
		   	  rblr.setSelected(true);
		   	  rbud.setSelected(false);
		   }
		   if (line.indexOf("direction=upDown")==0) {
		   	  rbauto.setSelected(false);
		   	  rblr.setSelected(false);
		   	  rbud.setSelected(true);
		   }
           if (line.indexOf("confirm=yes")==0) cbsave.setSelected(true);
           if (line.indexOf("confirm=no")==0)  cbsave.setSelected(false);
           if (line.indexOf("first=only")==0) cbfirst.setSelected(true);
           if (line.indexOf("frame=yes")==0) cbframe.setSelected(true);
           if (line.indexOf("frame=no")==0) cbframe.setSelected(false);
        }
        br.close();
        in.close();
		if (fpath.equals("")) fpath="trans";
		if (cwidth.equals("")) cwidth="30";
    } catch (IOException e) {
        fpath="trans";
		cwidth="30";
    }
  }
}
